;
; Local defs
;


if (Electron=1)
;        ROMPage=ROMPageElk                      ; Set rom page accordingly
endif

;True and false
FlagFalse	= &00
FlagTrue	= &01


; PrefixChar may be prepended to commands, to avoid clashes with commands in
; other roms. Note none of the commands should start with this character.
PrefixChar	= 'X'		
InvalidID	= &FF		; Use this to flag an invalid rom ID
OffsetFlagChar	= '+'		; This is used to flag an offset address.

;
; Error flags
;
ErrOK		= &00		; No error
ErrIO		= &01		; File error saving

;
; Help flags
;

HelpShort	= &00		; Short help title no date
HelpFull	= &01		; Full help title with date


; EOF flags for SRLOAD
NotEOF		= &00		; Not EOF, continue reading
EOFClose	= &FF		; EOF, we need to close file
EOFNoClose	= &FE		; EOF, we do not need to close file


; The area &A8-&AF in the zero page is reserved for OS command use

; As used by *SRZAP, *SRCOPY

SourceID	= &A8		; Source or first rom id
DestID		= &A9		; Dest or end rom id
OurID		= &AA		; Our rom ID
StackFrame	= &AB           ; Stack frame, used for *ALL* commands
MemPtr		= &AC		; Memory access pointer &AB/&AC
StartAddr	= MemPtr	; Alias to make code easier to read !

; AS used By *SRLOAD, *SRSAVE note some of these use the same addresses
; as above for differnt purposes !

CtrlBufAddr	= &A8		; Address of buffer for OSGBPB/OSFILE on stack only 1 byte as MSB always $01
FileBufPtr	= &AE		; File buffer pointer for transfer, &AE/&AF

DefFileBufAddr		= CasOutBuf			; File buffer is now cassette buffer.
DefFileBufAddrLSB	= DefFileBufAddr MOD 256	; For convenience
DefFileBufAddrMSB	= DefFileBufAddr DIV 256
DefFileBufSize		= &200				; Size of buffer for reading files (in cas buffer &900-&AFF).
DefFileBufSizeMSB	= DefFileBufSize DIV 256

; As used by *SRREAD *SRWRITE
SourceBufPtr	= MemPtr	; Source pointer
DestBufPtr	= &AE		; Destination pointer

; As used by *ROMS
ListFlags       = &AC           ; flags for listing roms
TablePtr	= &AD		; Saved rom type table pointer
InfoByte	= &AF		; Saved info byte

;
; Vars on stack, these are offsets from our stack frame, so should 
; be accessed with StackBase+Var,X with X having the base of our
; stack frame in.
;
; **PLEASE NOTE**
; GBPBBuf and OSFBuf share the same memory, so only one should be 
; used at one time !

DataLen		= StackBase+&00		; Length of data to move to/from swr
EndAddr		= StackBase+&02		; End addr of data to save (whilst calculating DataLen)
SaveStartAddr	= EndAddr		; Saved StartAddr for SRSAVE
OffsetFlag	= StackBase+&04		; Offset flag used to calculate above
RomTypeByte	= OffsetFlag		; Also used to pass rom type byte back to SRLOAD
OSFFlag		= OffsetFlag		; Also used to flag if we are using OSFILE in SRSAVE
SaveCliPtr	= StackBase+&05		; Saved CLI pointer
FileCloseFlag	= SaveCliPtr		; Also do we need to close file in SRLOAD
DataLenTmp	= StackBase+&06		; Temp used when calcualting datalen
DTAPages	= StackBase+&08		; Size of FileBuf in pages
DTABasePage	= StackBase+&09		; Base page of FileBuf
Flags		= StackBase+&0A		; Various flags, see below
GBPBBuf		= StackBase+&0B		; OSGBPB buffer
OSFBuf		= GBPBBuf		; OSFileBuf, as only one in use at once

;
; StackFrameLen **MUST** be equal to the combined size of the above.
;

StackFrameLen	= 2+2+1+1+2+1+1+1+OSFBufferLen				

;
; Flags
;
; used by SRLOAD, SRSAVE
FlagQuick	= &01			; Quick load using himem-oshwm flag
FlagScreen	= &02			; Quickload using screen ram flag
FlagInitRom	= &04			; Init rom when loaded

;used by ROMS
FlagVerbose     = &01                   ; verbose flag for *roms
FlagRomIsRAM    = &02                   ; SWR bank is RAM
FalgIS16K       = &04                   ; SWR bank is 16K

;
; Flags as chars as specified on command line
;

CharFlagQuick	= 'Q'                   ; Quick load using himem-oshwm flag
CharFlagScreen	= 'S'                   ; Quickload using screen ram flag
CharFlagInitRom	= 'I'                   ; Init rom when loaded
CharFlagVerbose = 'V'                   ; verbose flag for *roms


;
; Ofssets of GBPBBuf componets relative to StackFrame
; 
GPHandle	= GBPBBuf+OSGPHandle	; File handle, returned by OSFIND
GPDataPtr	= GBPBBuf+OSGPDataPtr	; Pointer to data
GPLength	= GBPBBuf+OSGPLength	; Length of data to transfer
GPSequence	= GBPBBuf+OSGPSequence	; Sequential pointer value to be used for transfer

;
; Offsets of OSFBuf components relative to stack frame
;

SFOSFFNameAddr	= OSFBuf+OSFFileNameAddr; Address of filename
SFOSFLoadAddr	= OSFBuf+OSFLoadAddr	; Load address of file
SFOSFExecAddr	= OSFBuf+OSFExecAddr	; Exec address of file
SFOSFStartAddr	= OSFBuf+OSFStartAddr	; Start address for save /
SFOSFLength	= OSFBuf+OSFLength	; Length of file otherwise
SFOSFEndAddr	= OSFBuf+OSFEndAddr	; End address for save /
SFOSFAttributes	= OSFBuf+OSFAttributes	; Attributes otherwise
